const API = require("../../../../lib/API")
const db = require("../../../../plugin/DataBase/db")
const AccessControl = require("../../../../lib/AccessControl")
const { BaseStdResponse } = require("../../../../BaseStdResponse")

class AdminGetRecordDetail extends API {
    constructor() {
        super();

        this.setPath('/Admin/Lepao/GetRecordDetail')
        this.setMethod('GET')
    }

    async onRequest(req, res) {
        let {
            uuid,
            session,
            id
        } = req.query

        if ([uuid, session, id].some(value => value === '' || value === null || value === undefined))
            return res.json({
                ...BaseStdResponse.MISSING_PARAMETER
            })

        // 检查 session
        if (!await AccessControl.checkSession(uuid, session))
            return res.status(401).json({
                ...BaseStdResponse.ACCESS_DENIED
            })

        // 检查权限
        let permission = await AccessControl.getPermission(uuid)
        if (!permission.includes("admin") && !permission.includes("server"))
            return res.json({
                ...BaseStdResponse.PERMISSION_DENIED
            })


        let sql = `
                SELECT 
                    r.time,
                    r.path_id,
                    r.task_id,
                    r.area,
                    r.path_data,
                    r.startTime,
                    r.endTime,
                    r.distance,
                    r.state,
                    r.lepao_account,
                    a.name
                FROM 
                    lepao_record r
                LEFT JOIN 
                    lepao_account a
                ON 
                    r.lepao_account = a.student_num
                WHERE 
                    r.id = ?
            `
        let rows = await db.query(sql, [id])

        if (!rows)
            return res.json({
                ...BaseStdResponse.MISSING_FILE,
                msg: '获取记录数据失败！'
            })

        if(rows.length === 0) 
           return res.json({
                ...BaseStdResponse.MISSING_FILE,
                msg: '记录不存在或已被删除！'
            }) 

        let data = rows[0]
        data.distance = Number(data.distance).toFixed(2)

        res.json({
            ...BaseStdResponse.OK,
            data
        })
    }
}

module.exports.AdminGetRecordDetail = AdminGetRecordDetail